
#define SATURATION 1.2

uniform sampler2D texture0;
uniform int UseTexture;

void main(void)
{
	// basic
	//gl_FragColor = gl_Color * texture2D(texture0, gl_TexCoord[0].xy) * 1.3;
	
	
	// With saturation
	
	const vec3 lumCoeff = vec3(0.2125, 0.7154, 0.0721);
	
	vec3 col = gl_Color.rgb;
	
	// Keep alpha separate, don't want it saturated.
	float a = gl_Color.a;
	
	// Texturing is optional.
	if (UseTexture == 1)
	{
		col *= texture2D(texture0, gl_TexCoord[0].xy).rgb;
		a *= texture2D(texture0, gl_TexCoord[0].xy).a;
	}
	
	vec3 intensity = vec3(dot(col, lumCoeff));
	col = mix(intensity, col, SATURATION);
	
	gl_FragColor = vec4(col, a);
}
